<?php // $Id: edit_form.php,v 1.4.2.2 2008/05/15 10:33:07 agrabs Exp $
/**
* prints the forms to choose an item-typ to create items and to choose a template to use
*
* @version $Id: edit_form.php,v 1.4.2.2 2008/05/15 10:33:07 agrabs Exp $
* @author Andreas Grabs
* @license http://www.gnu.org/copyleft/gpl.html GNU Public License
* @package msociograma
*/

require_once $CFG->libdir.'/formslib.php';

class msociograma_edit_add_question_form extends moodleform {
    function definition() {
        $mform =& $this->_form;

        //headline
        $mform->addElement('header', 'general', get_string('add_items', 'msociograma'));
        // visible elements
        // $msociograma_names = msociograma_load_msociograma_items('mod/msociograma/item');
        // $msociograma_names_options = array();
        // $msociograma_names_options[' '] = get_string('select');
        // foreach($msociograma_names as $fn) {
            // $msociograma_names_options[$fn] = get_string($fn,'msociograma');
        // }
      //  $msociograma_names_options = msociograma_load_msociograma_items_options();
        $msociograma_names_options[1] = 'ss';
	$msociograma_names_options[2] = 'cccc';

        $attributes = 'onChange="this.form.submit()"';
        $mform->addElement('select', 'typ', '', $msociograma_names_options, $attributes);

        // hidden elements
        $mform->addElement('hidden', 'id');
        $mform->addElement('hidden', 'position');
//-------------------------------------------------------------------------------
        // buttons
        $mform->addElement('submit', 'add_item', get_string('add_item', 'msociograma'));
    }
}

class msociograma_edit_use_template_form extends moodleform {
    var $msociogramadata;
    
    function definition() {
        $this->msociogramadata = new object();
        //this function can not be called, because not all data are available at this time
        //I use set_form_elements instead
    }
    
    //this function set the data used in set_form_elements()
    //in this form the only value have to set is course
    //eg: array('course' => $course)
    function set_msociogramadata($data) {
        if(is_array($data)) {
            foreach($data as $key => $val) {
                $this->msociogramadata->{$key} = $val;
            }
        }
    }
    
    //here the elements will be set
    //this function have to be called manually
    //the advantage is that the data are already set
    function set_form_elements(){
        $mform =& $this->_form;
        
        $elementgroup = array();
        //headline
        $mform->addElement('header', '', get_string('using_templates', 'msociograma'));
        // hidden elements
        $mform->addElement('hidden', 'id');
        
        // visible elements
        $templates_options = array();
        if($templates = msociograma_get_template_list($this->msociogramadata->course)){//get the templates
            $templates_options[' '] = get_string('select');
            foreach($templates as $template) {
                $templates_options[$template->id] = $template->name;
            }
            $attributes = 'onChange="this.form.submit()"';
            $elementgroup[] =& $mform->createElement('select', 'templateid', '', $templates_options, $attributes);
            // buttons
            $elementgroup[] =& $mform->createElement('submit', 'use_template', get_string('use_this_template', 'msociograma'));
        }else {
            $mform->addElement('static', 'info', get_string('no_templates_available_yet', 'msociograma'));
        }
        $mform->addGroup($elementgroup, 'elementgroup', '', array(' '), false);
        
    //-------------------------------------------------------------------------------
    }
}

class msociograma_edit_create_template_form extends moodleform {
    var $msociogramadata;
    
    function definition() {
    }
    
    function data_preprocessing(&$default_values){
        $default_values['templatename'] = '';
    }
    
    function set_msociogramadata($data) {
        if(is_array($data)) {
            foreach($data as $key => $val) {
                $this->msociogramadata->{$key} = $val;
            }
        }
    }
    
    function set_form_elements(){
        $mform =& $this->_form;
        $capabilities = $this->msociogramadata->capabilities;

        // hidden elements
        $mform->addElement('hidden', 'id');
        $mform->addElement('hidden', 'do_show');
        $mform->addElement('hidden', 'savetemplate', 1);

        //headline
        $mform->addElement('header', '', get_string('creating_templates', 'msociograma'));
        
        // visible elements
        $elementgroup = array();
        
        $elementgroup[] =& $mform->createElement('static', 'templatenamelabel', get_string('name', 'msociograma'));
        $elementgroup[] =& $mform->createElement('text', 'templatename', get_string('name', 'msociograma'), array('size'=>'40', 'maxlength'=>'200'));
        if($capabilities->createpublictemplate) {
            $elementgroup[] =& $mform->createElement('checkbox', 'ispublic', get_string('public', 'msociograma'), get_string('public', 'msociograma'));
        }
        
        // buttons
        $elementgroup[] =& $mform->createElement('submit', 'create_template', get_string('save_as_new_template', 'msociograma'));
        $mform->addGroup($elementgroup, 'elementgroup', get_string('name', 'msociograma'), array(' '), false);
        
        $mform->setType('templatename', PARAM_TEXT);
        
//-------------------------------------------------------------------------------
    }
}
?>
