<?php // $Id: lib.php,v 1.82.2.2 2008/07/24 21:58:06 skodak Exp $


if (!isset($CFG->msociograma_showrecentactivity)) {
    set_config("msociograma_showrecentactivity", true);
} 



// STANDARD MODULE FUNCTIONS /////////////////////////////////////////////////////////

function msociograma_user_outline($course, $user, $mod, $msociograma) {
    if ($entry = get_record("msociograma_entries", "userid", $user->id, "msociograma", $msociograma->id)) {

        $numwords = count(preg_split("/\w\b/", $entry->text)) - 1;

        $result->info = get_string("numwords", "", $numwords);
        $result->time = $entry->modified;
        return $result;
    }
    return NULL;
}


function msociograma_user_complete($course, $user, $mod, $msociograma) {

    if ($entry = get_record("msociograma_entries", "userid", $user->id, "msociograma", $msociograma->id)) {

        print_simple_box_start();
        if ($entry->modified) {
            echo "<p><font size=\"1\">".get_string("lastedited").": ".userdate($entry->modified)."</font></p>";
        }
        if ($entry->text) {
            echo format_text($entry->text, $entry->format);
        }
        if ($entry->teacher) {
            $grades = make_grades_menu($msociograma->assessed);
            msociograma_print_feedback($course, $entry, $grades);
        }
        print_simple_box_end();

    } else {
        print_string("noentry", "msociograma");
    }
}


function msociograma_user_complete_index($course, $user, $msociograma, $msociogramaopen, $heading) {
/// Prints a msociograma, entry and feedback ... used on the msociograma index page.

    if (isteacher($course->id)) {
        $entrycount = msociograma_count_entries($msociograma, get_current_group($course->id));
        $entryinfo  = "&nbsp;(<a href=\"report.php?id=$msociograma->coursemodule\">".get_string("viewallentries","msociograma", $entrycount)."</a>)";
    } else {
        $entryinfo = "";
    }

    $msociograma->name = "<a href=\"view.php?id=$msociograma->coursemodule\">".format_string($msociograma->name,true)."</a>";

    if ($heading) {
        echo "<h3>$heading - $msociograma->name$entryinfo</h3>";
    } else {
        echo "<h3>$msociograma->name$entryinfo</h3>";
    }

    print_simple_box_start("left", "90%");
    echo format_text($msociograma->intro,  $msociograma->introformat);
    print_simple_box_end();
    echo "<br clear=\"all\" />";
    echo "<br />";
    
    if (isstudent($course->id) or isteacher($course->id)) {

        print_simple_box_start("right", "90%");
    
        if ($msociogramaopen) {
            echo "<p align=\"right\"><a href=\"edit.php?id=$msociograma->coursemodule\">";
            echo get_string("edit")."</a></p>";
        } else {
            echo "<p align=\"right\"><a href=\"view.php?id=$msociograma->coursemodule\">";
            echo get_string("view")."</a></p>";
        }
    
        if ($entry = get_record("msociograma_entries", "userid", $user->id, "msociograma", $msociograma->id)) {
            if ($entry->modified) {
                echo "<p align=\"center\"><font size=\"1\">".get_string("lastedited").": ".userdate($entry->modified)."</font></p>";
            }
            if ($entry->text) {
                echo format_text($entry->text, $entry->format);
            }
            if ($entry->teacher) {
                $grades = make_grades_menu($msociograma->assessed);
                msociograma_print_feedback($course, $entry, $grades);
            }
        } else {
            print_string("noentry", "msociograma");
        }
    
        print_simple_box_end();
        echo "<br clear=\"all\" />";
        echo "<br />";
    }

}


function msociograma_cron () {
// Function to be run periodically according to the moodle cron
// Finds all msociograma notifications that have yet to be mailed out, and mails them

    global $CFG, $USER;

    $cutofftime = time() - $CFG->maxeditingtime;

    if ($entries = msociograma_get_unmailed_graded($cutofftime)) {
        $timenow = time();

        foreach ($entries as $entry) {

            echo "Processing msociograma entry $entry->id\n";

            if (! $user = get_record("user", "id", "$entry->userid")) {
                echo "Could not find user $entry->userid\n";
                continue;
            }

            $USER->lang = $user->lang;

            if (! $course = get_record("course", "id", "$entry->course")) {
                echo "Could not find course $entry->course\n";
                continue;
            }

            if (! isstudent($course->id, $user->id) and !isteacher($course->id, $user->id)) {
                continue;  // Not an active participant
            }

            if (! $teacher = get_record("user", "id", "$entry->teacher")) {
                echo "Could not find teacher $entry->teacher\n";
                continue;
            }


            if (! $mod = get_coursemodule_from_instance("msociograma", $entry->msociograma, $course->id)) {
                echo "Could not find course module for msociograma id $entry->msociograma\n";
                continue;
            }

            unset($msociogramainfo);
            $msociogramainfo->teacher = fullname($teacher);
            $msociogramainfo->msociograma = format_string($entry->name,true);
            $msociogramainfo->url = "$CFG->wwwroot/mod/msociograma/view.php?id=$mod->id";
            $modnamepl = get_string( 'modulenameplural','msociograma' );
            $msubject = get_string( 'mailsubject','msociograma' );

            $postsubject = "$course->shortname: $msubject: ".format_string($entry->name,true);
            $posttext  = "$course->shortname -> $modnamepl -> ".format_string($entry->name,true)."\n";
            $posttext .= "---------------------------------------------------------------------\n";
            $posttext .= get_string("msociogramamail", "msociograma", $msociogramainfo)."\n";
            $posttext .= "---------------------------------------------------------------------\n";
            if ($user->mailformat == 1) {  // HTML
                $posthtml = "<p><font face=\"sans-serif\">".
                "<a href=\"$CFG->wwwroot/course/view.php?id=$course->id\">$course->shortname</a> ->".
                "<a href=\"$CFG->wwwroot/mod/msociograma/index.php?id=$course->id\">msociogramas</a> ->".
                "<a href=\"$CFG->wwwroot/mod/msociograma/view.php?id=$mod->id\">".format_string($entry->name,true)."</a></font></p>";
                $posthtml .= "<hr /><font face=\"sans-serif\">";
                $posthtml .= "<p>".get_string("msociogramamailhtml", "msociograma", $msociogramainfo)."</p>";
                $posthtml .= "</font><hr />";
            } else {
              $posthtml = "";
            }

            if (! email_to_user($user, $teacher, $postsubject, $posttext, $posthtml)) {
                echo "Error: msociograma cron: Could not send out mail for id $entry->id to user $user->id ($user->email)\n";
            }
            if (! set_field("msociograma_entries", "mailed", "1", "id", "$entry->id")) {
                echo "Could not update the mailed field for id $entry->id\n";
            }
        }
    }

    return true;
}

function msociograma_print_recent_activity($course, $isteacher, $timestart) {
    global $CFG;

    if (!empty($CFG->msociograma_showrecentactivity)) {    // Don't even bother
        return false;
    }

    $content = false;
    $msociogramas = NULL;

    // log table should not be used here

    if (!$logs = get_records_select('log', 'time > \''.$timestart.'\' AND '.
                                           'course = \''.$course->id.'\' AND '.
                                           'module = \'msociograma\' AND '.
                                           '(action = \'add entry\' OR action = \'update entry\')', 'time ASC')){
        return false;
    }

    foreach ($logs as $log) {
        ///Get msociograma info.  I'll need it later
        $j_log_info = msociograma_log_info($log);

        $cm = $modinfo->instances['msociograma'][$j_log_info->id];
        if (!$cm->uservisible) {
            continue;
        }

        if (!isset($msociogramas[$log->info])) {
            $msociogramas[$log->info] = $j_log_info;
            $msociogramas[$log->info]->time = $log->time;
            $msociogramas[$log->info]->url = str_replace('&', '&amp;', $log->url);
        }
    }

    if ($msociogramas) {
        $content = true;
        print_headline(get_string('newmsociogramaentries', 'msociograma').':');
        foreach ($msociogramas as $msociograma) {
            print_recent_activity_note($msociograma->time, $msociograma, $msociograma->name,
                                       $CFG->wwwroot.'/mod/msociograma/'.$msociograma->url);
        }
    }
 
    return $content;
}

function msociograma_grades($msociogramaid) {
/// Must return an array of grades, indexed by user, and a max grade.

    if (!$msociograma = get_record("msociograma", "id", $msociogramaid)) {
        return NULL;
    }

    $grades = get_records_menu("msociograma_entries", "msociograma", 
                               $msociograma->id, "", "userid,rating");

    if ($msociograma->assessed > 0) {
        $return->grades = $grades;
        $return->maxgrade = $msociograma->assessed;

    } else if ($msociograma->assessed == 0) {
        return NULL;

    } else {
        if ($scale = get_record("scale", "id", - $msociograma->assessed)) {
            $scalegrades = make_menu_from_list($scale->scale);
            if ($grades) {
                foreach ($grades as $key => $grade) {
                    $grades[$key] = $scalegrades[$grade];
                }
            }
        }
        $return->grades = $grades;
        $return->maxgrade = "";
    }

    return $return;
}

function msociograma_get_participants($msociogramaid) {
//Returns the users with data in one msociograma
//(users with records in msociograma_entries, students and teachers)

    global $CFG;

    //Get students
    $students = get_records_sql("SELECT DISTINCT u.id, u.id
                                 FROM {$CFG->prefix}user u,
                                      {$CFG->prefix}msociograma_entries j
                                 WHERE j.msociograma = '$msociogramaid' and
                                       u.id = j.userid");
    //Get teachers
    $teachers = get_records_sql("SELECT DISTINCT u.id, u.id
                                 FROM {$CFG->prefix}user u,
                                      {$CFG->prefix}msociograma_entries j
                                 WHERE j.msociograma = '$msociogramaid' and
                                       u.id = j.teacher");

    //Add teachers to students
    if ($teachers) {
        foreach ($teachers as $teacher) {
            $students[$teacher->id] = $teacher;
        }
    }
    //Return students array (it contains an array of unique users)
    return ($students);
}

function msociograma_scale_used ($msociogramaid,$scaleid) {
//This function returns if a scale is being used by one msociograma
    
    $return = false;                  
                                 
    $rec = get_record("msociograma","id","$msociogramaid","assessed","-$scaleid");

    if (!empty($rec) && !empty($scaleid)) {
        $return = true;
    }

    return $return;
}

/**
 * Checks if scale is being used by any instance of msociograma
 *
 * This is used to find out if scale used anywhere
 * @param $scaleid int
 * @return boolean True if the scale is used by any msociograma
 */
function msociograma_scale_used_anywhere($scaleid) {
    if ($scaleid and record_exists('msociograma', 'assessed', -$scaleid)) {
        return true;
    } else {
        return false;
    }
}

// SQL FUNCTIONS ///////////////////////////////////////////////////////////////////

function msociograma_get_users_done($msociograma) {
    global $CFG;

    $msociogramas = get_records_sql ("SELECT u.*
                                  FROM {$CFG->prefix}msociograma_entries j,
                                       {$CFG->prefix}user u 
                                 WHERE j.userid = u.id
                                   AND j.msociograma = $msociograma->id
                              ORDER BY j.modified DESC");

    if (empty($msociogramas)) {
        return NULL;
    }

    // remove unenrolled participants
    foreach ($msociogramas as $key=>$user) {
        if (!isteacher($msociograma->course, $user->id) and !isstudent($msociograma->course, $user->id)) {
            unset($msociogramas[$key]);
        } 
    }
    return $msociogramas;
}

function msociograma_count_entries($msociograma, $groupid=0) {
/// Counts all the msociograma entries (optionally in a given group)

    global $CFG, $db;

    if ($groupid) {     /// How many in a particular group?
        return count_records_sql("SELECT COUNT(*) 
                                     FROM {$CFG->prefix}msociograma_entries j,
                                          {$CFG->prefix}groups_members g
                                    WHERE j.msociograma = $msociograma->id 
                                      AND g.groupid = '$groupid' 
                                      AND j.userid = g.userid");

    } else { /// Count all the entries from the whole course
    
        $msociogramas = get_records_sql ("SELECT u.*
                                      FROM {$CFG->prefix}msociograma_entries j,
                                           {$CFG->prefix}user u 
                                     WHERE j.userid = u.id
                                       AND j.msociograma = $msociograma->id
                                  ORDER BY j.modified DESC");

        if (empty($msociogramas)) {
            return 0;
        }

        // remove unenrolled participants
        foreach ($msociogramas as $key=>$user) {
            if (!isteacher($msociograma->course, $user->id) and !isstudent($msociograma->course, $user->id)) {
                unset($msociogramas[$key]);
            } 
        }
        return count($msociogramas);
    }
}


function msociograma_get_unmailed_graded($cutofftime) {
    global $CFG;
    return get_records_sql("SELECT e.*, j.course, j.name
                              FROM {$CFG->prefix}msociograma_entries e, 
                                   {$CFG->prefix}msociograma j
                             WHERE e.mailed = '0' 
                               AND e.timemarked < '$cutofftime' 
                               AND e.timemarked > 0
                               AND e.msociograma = j.id");
}

function msociograma_log_info($log) {
    global $CFG;
    return get_record_sql("SELECT j.*, u.firstname, u.lastname
                             FROM {$CFG->prefix}msociograma j, 
                                  {$CFG->prefix}msociograma_entries e, 
                                  {$CFG->prefix}user u
                            WHERE e.id = '$log->info' 
                              AND e.msociograma = j.id
                              AND e.userid = u.id");
}

// OTHER msociograma FUNCTIONS ///////////////////////////////////////////////////////////////////



function msociograma_print_user_entry($course, $user, $entry, $teachers, $grades) {
    global $USER;

    echo "\n<table border=\"1\" cellspacing=\"0\" valign=\"top\" cellpadding=\"10\">";
        
    echo "\n<tr>";
    echo "\n<td rowspan=\"2\" width=\"35\" valign=\"top\">";
    print_user_picture($user->id, $course->id, $user->picture);
    echo "</td>";
    echo "<td nowrap=\"nowrap\" width=\"100%\">".fullname($user);
    if ($entry) {
        echo "&nbsp;&nbsp;<font size=\"1\">".get_string("lastedited").": ".userdate($entry->modified)."</font>";
    }
    echo "</td>";
    echo "</tr>";

    echo "\n<tr><td width=\"100%\">";
    if ($entry) {
        echo format_text($entry->text, $entry->format);
    } else {
        print_string("noentry", "msociograma");
    }
    echo "</td></tr>";

    if ($entry) {
        echo "\n<tr>";
        echo "<td width=\"35\" valign=\"top\">";
        if (!$entry->teacher) {
            $entry->teacher = $USER->id;
        }
        print_user_picture($entry->teacher, $course->id, $teachers[$entry->teacher]->picture);
        echo "</td>";
        echo "<td>".get_string("feedback").":";
        choose_from_menu($grades, "r$entry->id", $entry->rating, get_string("nograde")."...");
        if ($entry->timemarked) {
            echo "&nbsp;&nbsp;<font size=\"1\">".userdate($entry->timemarked)."</font>";
        }
        echo "<br /><textarea name=\"c$entry->id\" rows=\"12\" cols=\"60\" wrap=\"virtual\">";
        p($entry->entrycomment);
        echo "</textarea><br />";
        echo "</td></tr>";
    }
    echo "</table><br clear=\"all\" />\n";
}


function msociograma_add_instance($msociograma) {
// Given an object containing all the necessary data, 
// (defined by the form in mod.html) this function 
// will create a new instance and return the id number 
// of the new instance.

    $msociograma->timemodified = time();

    return insert_record("msociograma", $msociograma);
}


function msociograma_update_instance($msociograma) {
// Given an object containing all the necessary data, 
// (defined by the form in mod.html) this function 
// will update an existing instance with new data.

    $msociograma->timemodified = time();
    $msociograma->id = $msociograma->instance;

    return update_record("msociograma", $msociograma);
}


function msociograma_delete_instance($id) {
// Given an ID of an instance of this module, 
// this function will permanently delete the instance 
// and any data that depends on it.  

    if (! $msociograma = get_record("msociograma", "id", $id)) {
        return false;
    }

    $result = true;

    if (! delete_records("msociograma_entries", "msociograma", $msociograma->id)) {
        $result = false;
    }

    if (! delete_records("msociograma", "id", $msociograma->id)) {
        $result = false;
    }

    return $result;

}


function msociograma_print_feedback($course, $entry, $grades) {
    global $CFG;

    if (! $teacher = get_record('user', 'id', $entry->teacher)) {
        error('Weird msociograma error');
    }

    echo '<table cellspacing="0" align="center" class="feedbackbox">';

    echo '<tr>';
    echo '<td class="left picture">';
    print_user_picture($teacher->id, $course->id, $teacher->picture);
    echo '</td>';
    echo '<td class="entryheader">';
    echo '<span class="author">'.fullname($teacher).'</span>';
    echo '&nbsp;&nbsp;<span class="time">'.userdate($entry->timemarked).'</span>';
    echo '</td>';
    echo '</tr>';

    echo '<tr>';
    echo '<td class="left side">&nbsp;</td>';
    echo '<td class="entrycontent">';

    echo '<div class="grade">';
    
    if (!empty($entry->rating) and !empty($grades[$entry->rating])) {
        echo get_string('grade').': ';
        echo $grades[$entry->rating];
    } else {
        print_string('nograde');
    }
    echo '</div>';

    echo format_text($entry->entrycomment);
    echo '</td></tr></table>';
}

function msociograma_get_view_actions() {
    return array('view','view all','view responses');
}

function msociograma_get_post_actions() {
    return array('add entry','update entry','update feedback');
}

/**
 * Returns all other caps used in module
 */
function msociograma_get_extra_capabilities() {
    return array('moodle/site:accessallgroups');
}



?>
